; AutoLisp routine by Dixon Mak  April 1995
; Compuserve: 70672,2361
; INTERNET:   70672,2361@compuserve.com
;
; This routine is to draw a 2'-6" right hand door. A right hand door
; is a door that swings away & to the right from where you are facing the
; door. If the swing is towards you & to the right, when you are facing the
; door, then this would be a left hand door.

(defun c:2-6RD (/ p1 p2 p3 p4 b1 b2 r1 rd wt a ip osm cl)

  (defun dtr (a) ;converts degrees to radians
    (* pi (/ a 180.0))
  )
  (defun rtd (a) ;converts radians to degrees
    (/ (* a 180.0) pi)
  )

  (graphscr)
  (setq osm (getvar "osmode"))
  (setq cl (getvar "clayer"))
  (setvar "cmdecho" 0)

  (setvar "osmode" 32)
  (setq r1 (getpoint "\nPick corner wall nearest hinge): "))
  (setvar "osmode" 512)
  (setq b1 (getpoint r1 "\nPick any point on wall where door sits: "))
  (setq a (angle r1 b1))

  (if (null wt1) (setq wt1 0.0))
  (progn
    (initget 4)
    (setq wt (getdist
    (strcat "\nEnter or pick wall thickness<" (rtos wt1) ">: "))
    )
    (if (null wt)
        (setq wt wt1)
        (setq wt1 wt)
    )
  )
  (if (null rd1) (setq rd1 0.0))
  (progn
    (initget 4)
    (setq rd (getdist
    (strcat "\nEnter distance from hinge to corner wall<" (rtos rd1) ">: "))
    )
    (if (null rd)
        (setq rd rd1)
        (setq rd1 rd)
    )
  )
  
  (setvar "osmode" 0)
  (setq b2 (polar b1 (+ a (dtr 90)) wt))
  (setq ip (polar r1 (+ a (dtr 0)) rd))
  (setq p2 (polar ip (+ a (dtr 0)) 30))
  (setq p3 (polar ip (+ a (dtr 90)) wt))
  (setq p4 (polar p2 (+ a (dtr 90)) wt))

  (command "break" b1 "f" ip p2)
  (command "break" b2 "f" p3 p4)
  
  (if (tblsearch "layer" "walls")      ;search layer called "Walls"
      (command "layer" "s" "walls" "") ;set to layer "Walls"
      (progn                           ;if layer "Walls" doesn't exist
        (command "layer" "m" "walls")  ;make layer "Walls"
        (command "c" "2" "")           ;set to color yellow
        (command "")
      ); end progn
  ); end if

  (command "line" ip p3 "")
  (command "line" p2 p4 "")

  (command "insert" "2-6RD" ip "1" "1" (- (rtd a) 180)) ;insert door block
  (command "explode" "l")
  
  (command "layer" "s" cl "")
  (setvar "osmode" osm)
  (setvar "cmdecho" 1)
  (princ)
)
